Index: uspace/lib/libc/generic/vfs/canonify.c
===================================================================
--- uspace/lib/libc/generic/vfs/canonify.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/generic/vfs/canonify.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -142,5 +142,5 @@
 	t->start[-1] = '\0';
 }
-/** Eat the extra '/'.
+/** Eat the extra '/'..
  *
  * @param t		The current TK_SLASH token.
@@ -288,15 +288,9 @@
  *
  * A file system path is canonical, if the following holds:
- *
- * 1) the path is absolute
- *    (i.e. a/b/c is not canonical)
- * 2) there is no trailing slash in the path if it has components
- *    (i.e. /a/b/c/ is not canonical)
- * 3) there is no extra slash in the path
- *    (i.e. /a//b/c is not canonical)
- * 4) there is no '.' component in the path
- *    (i.e. /a/./b/c is not canonical)
- * 5) there is no '..' component in the path
- *    (i.e. /a/b/../c is not canonical)
+ * 1) the path is absolute (i.e. a/b/c is not canonical)
+ * 2) there is no trailing slash in the path (i.e. /a/b/c is not canonical)
+ * 3) there is no extra slash in the path (i.e. /a//b/c is not canonical)
+ * 4) there is no '.' component in the path (i.e. /a/./b/c is not canonical)
+ * 5) there is no '..' component in the path (i.e. /a/b/../c is not canonical) 
  *
  * This function makes a potentially non-canonical file system path canonical.
Index: uspace/lib/libc/include/atomic.h
===================================================================
--- uspace/lib/libc/include/atomic.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/atomic.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2009 Jakub Jermar
+ * Copyright (c) 2006 Jakub Jermar
  * All rights reserved.
  *
@@ -36,5 +36,19 @@
 #define LIBC_ATOMIC_H_
 
+typedef struct atomic {
+	volatile long count;
+} atomic_t;
+
 #include <libarch/atomic.h>
+
+static inline void atomic_set(atomic_t *val, long i)
+{
+        val->count = i;
+}
+
+static inline long atomic_get(atomic_t *val)
+{
+        return val->count;
+}
 
 #endif
Index: uspace/lib/libc/include/futex.h
===================================================================
--- uspace/lib/libc/include/futex.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/futex.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -46,4 +46,5 @@
 extern int futex_down(futex_t *futex);
 extern int futex_trydown(futex_t *futex);
+extern int futex_down_timeout(futex_t *futex, uint32_t usec, int flags);
 extern int futex_up(futex_t *futex);
 
Index: uspace/lib/libc/include/io/console.h
===================================================================
--- uspace/lib/libc/include/io/console.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/io/console.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -69,5 +69,4 @@
 
 extern int console_get_size(int phone, int *cols, int *rows);
-extern int console_get_pos(int phone, int *col, int *row);
 extern void console_goto(int phone, int col, int row);
 
Index: uspace/lib/libc/include/ipc/console.h
===================================================================
--- uspace/lib/libc/include/ipc/console.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/ipc/console.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -43,5 +43,4 @@
 	CONSOLE_GET_COLOR_CAP,
 	CONSOLE_GET_EVENT,
-	CONSOLE_GET_POS,
 	CONSOLE_GOTO,
 	CONSOLE_CLEAR,
Index: uspace/lib/libc/include/string.h
===================================================================
--- uspace/lib/libc/include/string.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/string.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -73,7 +73,5 @@
 extern void str_append(char *dest, size_t size, const char *src);
 
-extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
-extern char *wstr_to_astr(const wchar_t *src);
-extern void str_to_wstr(wchar_t *dest, size_t dlen, const char *src);
+extern void wstr_nstr(char *dst, const wchar_t *src, size_t size);
 
 extern char *str_chr(const char *str, wchar_t ch);
Index: uspace/lib/libc/include/unistd.h
===================================================================
--- uspace/lib/libc/include/unistd.h	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/lib/libc/include/unistd.h	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -51,6 +51,4 @@
 #endif
 
-typedef uint32_t useconds_t;
-
 extern int dup2(int oldfd, int newfd);
 
@@ -70,6 +68,6 @@
 
 extern void _exit(int status) __attribute__ ((noreturn));
-extern int usleep(useconds_t uses);
-extern unsigned int sleep(unsigned int se);
+extern int usleep(unsigned long usec);
+extern unsigned int sleep(unsigned int seconds);
 
 #endif
Index: uspace/srv/console/console.c
===================================================================
--- uspace/srv/console/console.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/srv/console/console.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -601,8 +601,4 @@
 				    IPC_GET_ARG2(call));
 			break;
-		case CONSOLE_GET_POS:
-			arg1 = cons->scr.position_x;
-			arg2 = cons->scr.position_y;
-			break;
 		case CONSOLE_GET_SIZE:
 			arg1 = fb_info.cols;
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/srv/fs/fat/fat_ops.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -363,14 +363,9 @@
 				}
 				rc = fat_node_get_core(&nodep, idx);
+				assert(rc == EOK);
 				fibril_mutex_unlock(&idx->lock);
-				if (rc != EOK) {
-					(void) block_put(b);
-					return rc;
-				}
+				(void) block_put(b);
 				*rfn = FS_NODE(nodep);
-				rc = block_put(b);
-				if (rc != EOK)
-					(void) fat_node_put(*rfn);
-				return rc;
+				return EOK;
 			}
 		}
@@ -1077,18 +1072,9 @@
 			rc = fat_block_get(&b, bs, nodep, pos / bps,
 			    BLOCK_FLAGS_NONE);
-			if (rc != EOK) {
-				fat_node_put(fn);
-				ipc_answer_0(callid, rc);
-				ipc_answer_0(rid, rc);
-				return;
-			}
+			assert(rc == EOK);
 			(void) async_data_read_finalize(callid, b->data + pos % bps,
 			    bytes);
 			rc = block_put(b);
-			if (rc != EOK) {
-				fat_node_put(fn);
-				ipc_answer_0(rid, rc);
-				return;
-			}
+			assert(rc == EOK);
 		}
 	} else {
@@ -1114,6 +1100,5 @@
 			rc = fat_block_get(&b, bs, nodep, bnum,
 			    BLOCK_FLAGS_NONE);
-			if (rc != EOK)
-				goto err;
+			assert(rc == EOK);
 			for (o = pos % (bps / sizeof(fat_dentry_t));
 			    o < bps / sizeof(fat_dentry_t);
@@ -1126,6 +1111,5 @@
 				case FAT_DENTRY_LAST:
 					rc = block_put(b);
-					if (rc != EOK)
-						goto err;
+					assert(rc == EOK);
 					goto miss;
 				default:
@@ -1133,26 +1117,17 @@
 					fat_dentry_name_get(d, name);
 					rc = block_put(b);
-					if (rc != EOK)
-						goto err;
+					assert(rc == EOK);
 					goto hit;
 				}
 			}
 			rc = block_put(b);
-			if (rc != EOK)
-				goto err;
+			assert(rc == EOK);
 			bnum++;
 		}
 miss:
-		rc = fat_node_put(fn);
-		ipc_answer_0(callid, rc != EOK ? rc : ENOENT);
-		ipc_answer_1(rid, rc != EOK ? rc : ENOENT, 0);
-		return;
-
-err:
-		(void) fat_node_put(fn);
-		ipc_answer_0(callid, rc);
-		ipc_answer_0(rid, rc);
-		return;
-
+		fat_node_put(fn);
+		ipc_answer_0(callid, ENOENT);
+		ipc_answer_1(rid, ENOENT, 0);
+		return;
 hit:
 		(void) async_data_read_finalize(callid, name, str_size(name) + 1);
@@ -1160,6 +1135,6 @@
 	}
 
-	rc = fat_node_put(fn);
-	ipc_answer_1(rid, rc, (ipcarg_t)bytes);
+	fat_node_put(fn);
+	ipc_answer_1(rid, EOK, (ipcarg_t)bytes);
 }
 
@@ -1172,5 +1147,5 @@
 	fat_node_t *nodep;
 	fat_bs_t *bs;
-	size_t bytes, size;
+	size_t bytes;
 	block_t *b;
 	uint16_t bps;
@@ -1195,5 +1170,5 @@
 	size_t len;
 	if (!async_data_write_receive(&callid, &len)) {
-		(void) fat_node_put(fn);
+		fat_node_put(fn);
 		ipc_answer_0(callid, EINVAL);
 		ipc_answer_0(rid, EINVAL);
@@ -1226,33 +1201,18 @@
 		 */
 		rc = fat_fill_gap(bs, nodep, FAT_CLST_RES0, pos);
-		if (rc != EOK) {
-			(void) fat_node_put(fn);
-			ipc_answer_0(callid, rc);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		rc = fat_block_get(&b, bs, nodep, pos / bps, flags);
-		if (rc != EOK) {
-			(void) fat_node_put(fn);
-			ipc_answer_0(callid, rc);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		(void) async_data_write_finalize(callid, b->data + pos % bps,
 		    bytes);
 		b->dirty = true;		/* need to sync block */
 		rc = block_put(b);
-		if (rc != EOK) {
-			(void) fat_node_put(fn);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		if (pos + bytes > nodep->size) {
 			nodep->size = pos + bytes;
 			nodep->dirty = true;	/* need to sync node */
 		}
-		size = nodep->size;
-		rc = fat_node_put(fn);
-		ipc_answer_2(rid, rc, bytes, nodep->size);
+		ipc_answer_2(rid, EOK, bytes, nodep->size);	
+		fat_node_put(fn);
 		return;
 	} else {
@@ -1261,4 +1221,5 @@
 		 * clusters for the node and zero them out.
 		 */
+		int status;
 		unsigned nclsts;
 		fat_cluster_t mcl, lcl; 
@@ -1266,40 +1227,23 @@
 		nclsts = (ROUND_UP(pos + bytes, bpc) - boundary) / bpc;
 		/* create an independent chain of nclsts clusters in all FATs */
-		rc = fat_alloc_clusters(bs, dev_handle, nclsts, &mcl, &lcl);
-		if (rc != EOK) {
+		status = fat_alloc_clusters(bs, dev_handle, nclsts, &mcl, &lcl);
+		if (status != EOK) {
 			/* could not allocate a chain of nclsts clusters */
-			(void) fat_node_put(fn);
-			ipc_answer_0(callid, rc);
-			ipc_answer_0(rid, rc);
+			fat_node_put(fn);
+			ipc_answer_0(callid, status);
+			ipc_answer_0(rid, status);
 			return;
 		}
 		/* zero fill any gaps */
 		rc = fat_fill_gap(bs, nodep, mcl, pos);
-		if (rc != EOK) {
-			(void) fat_free_clusters(bs, dev_handle, mcl);
-			(void) fat_node_put(fn);
-			ipc_answer_0(callid, rc);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		rc = _fat_block_get(&b, bs, dev_handle, lcl, (pos / bps) % spc,
 		    flags);
-		if (rc != EOK) {
-			(void) fat_free_clusters(bs, dev_handle, mcl);
-			(void) fat_node_put(fn);
-			ipc_answer_0(callid, rc);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		(void) async_data_write_finalize(callid, b->data + pos % bps,
 		    bytes);
 		b->dirty = true;		/* need to sync block */
 		rc = block_put(b);
-		if (rc != EOK) {
-			(void) fat_free_clusters(bs, dev_handle, mcl);
-			(void) fat_node_put(fn);
-			ipc_answer_0(rid, rc);
-			return;
-		}
+		assert(rc == EOK);
 		/*
 		 * Append the cluster chain starting in mcl to the end of the
@@ -1307,14 +1251,9 @@
 		 */
 		rc = fat_append_clusters(bs, nodep, mcl);
-		if (rc != EOK) {
-			(void) fat_free_clusters(bs, dev_handle, mcl);
-			(void) fat_node_put(fn);
-			ipc_answer_0(rid, rc);
-			return;
-		}
-		nodep->size = size = pos + bytes;
+		assert(rc == EOK);
+		nodep->size = pos + bytes;
 		nodep->dirty = true;		/* need to sync node */
-		rc = fat_node_put(fn);
-		ipc_answer_2(rid, rc, bytes, size);
+		ipc_answer_2(rid, EOK, bytes, nodep->size);
+		fat_node_put(fn);
 		return;
 	}
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision fbcfc4dae9c8bbb7a192b0d0050fd7e51c5faf32)
+++ uspace/srv/vfs/vfs_file.c	(revision cb3d641acfaba056443f5a2ae15d649889c2c7a7)
@@ -89,5 +89,5 @@
 	unsigned int i;
 	if (desc)
-		i = MAX_OPEN_FILES - 1;
+		i = MAX_OPEN_FILES;
 	else
 		i = 0;
@@ -111,5 +111,5 @@
 			i--;
 		} else {
-			if (i == MAX_OPEN_FILES - 1)
+			if (i == MAX_OPEN_FILES)
 				break;
 			
